tclap: TCLAP::MultiArg< T > Class Template Reference

Main Page | Namespace List | Class Hierarchy | Class List | Directories | File List | Namespace Members | Class Members | File Members

# TCLAP::MultiArg< T > Class Template Reference

An argument that allows multiple values of type T to be specified. More...

`#include <MultiArg.h>`

Inheritance diagram for TCLAP::MultiArg< T >:

[legend]
Collaboration diagram for TCLAP::MultiArg< T >:

[legend]
List of all members.

## Public Types
typedef std::vector< T > | container_type
typedef container_type::iterator | iterator
typedef container_type::const_iterator | const_iterator
## Public Member Functions
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, const std::string &typeDesc, Visitor *v=NULL)
| Constructor.
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, const std::string &typeDesc, CmdLineInterface &parser, Visitor *v=NULL)
| Constructor.
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, Constraint< T > *constraint, Visitor *v=NULL)
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, Constraint< T > *constraint, CmdLineInterface &parser, Visitor *v=NULL)
| Constructor.
virtual bool | processArg (int *i, std::vector< std::string > &args)
| Handles the processing of the argument.
const std::vector< T > & | getValue ()
| Returns a vector of type T containing the values parsed from the command line.
const_iterator | begin () const
| Returns an iterator over the values parsed from the command line.
const_iterator | end () const
| Returns the end of the values parsed from the command line.
virtual std::string | shortID (const std::string &val="val") const
virtual std::string | longID (const std::string &val="val") const
virtual bool | isRequired () const
| Once we've matched the first value, then the arg is no longer required.
virtual bool | allowMore ()
| Used for MultiArgs and XorHandler to determine whether args can still be set.
virtual void | reset ()
| Clears the Arg object and allows it to be reused by new command lines.
## Protected Member Functions
void | _extractValue (const std::string &val)
| Extracts the value from the string.
## Protected Attributes
std::vector< T > | _values
| The list of values parsed from the CmdLine.
std::string | _typeDesc
| The description of type T to be used in the usage.
Constraint< T > * | _constraint
| A list of constraint on this Arg.
bool | _allowMore
| Used by XorHandler to decide whether to keep parsing for this arg.

## Detailed Description

### template<class T>
class TCLAP::MultiArg< T >

An argument that allows multiple values of type T to be specified.

Very similar to a ValueArg, except a vector of values will be returned instead of just one.

Definition at line 39 of file MultiArg.h.

## Member Typedef Documentation

template<class T>
typedef container_type::const_iterator TCLAP::MultiArg< T >::const_iterator

| Definition at line 44 of file MultiArg.h.

template<class T>
typedef std::vector<T> TCLAP::MultiArg< T >::container_type

| Definition at line 42 of file MultiArg.h.

template<class T>
typedef container_type::iterator TCLAP::MultiArg< T >::iterator

| Definition at line 43 of file MultiArg.h.

## Constructor & Destructor Documentation

template<class T>
TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | const std::string & | typeDesc,
|  | Visitor * | v = `NULL`
| ) |

  | Constructor. Parameters:
  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.
Definition at line 227 of file MultiArg.h.

template<class T>
TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | const std::string & | typeDesc,
|  | CmdLineInterface & | parser,
|  | Visitor * | v = `NULL`
| ) |

  | Constructor. Parameters:
  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  | parser | - A CmdLine parser object to add this Arg to
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.
Definition at line 242 of file MultiArg.h. References TCLAP::CmdLineInterface::add().

Here is the call graph for this function:

template<class T>
TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | Constraint< T > * | constraint,
|  | Visitor * | v = `NULL`
| ) |

  | Parameters:
  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | constraint | - A pointer to a Constraint object used to constrain this Arg.
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.
Definition at line 262 of file MultiArg.h.

template<class T>
TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | Constraint< T > * | constraint,
|  | CmdLineInterface & | parser,
|  | Visitor * | v = `NULL`
| ) |

  | Constructor. Parameters:
  | flag | - The one character flag that identifies this argument on the command line.
  | name | - A one word name for the argument. Can be used as a long flag on the command line.
  | desc | - A description of what the argument is for or does.
  | req | - Whether the argument is required on the command line.
  | constraint | - A pointer to a Constraint object used to constrain this Arg.
  | parser | - A CmdLine parser object to add this Arg to
  | v | - An optional visitor. You probably should not use this unless you have a very good reason.
Definition at line 277 of file MultiArg.h. References TCLAP::CmdLineInterface::add().

Here is the call graph for this function:

## Member Function Documentation

template<class T>
void TCLAP::MultiArg< T >::_extractValue | ( | const std::string & | val | ) | `[protected]`

  | Extracts the value from the string. Attempts to parse string as type T, if this fails an exception is thrown. Parameters:
  | val | - The string to be read.
Definition at line 387 of file MultiArg.h. References TCLAP::MultiArg< T >::_constraint, TCLAP::MultiArg< T >::_values, TCLAP::ExtractValue(), and TCLAP::Arg::toString(). Referenced by TCLAP::UnlabeledMultiArg< T >::processArg(), and TCLAP::MultiArg< T >::processArg().

Here is the call graph for this function:

template<class T>
bool TCLAP::MultiArg< T >::allowMore | ( |  | ) | `[virtual]`

| Used for MultiArgs and XorHandler to determine whether args can still be set. Reimplemented from TCLAP::Arg. Definition at line 406 of file MultiArg.h. References TCLAP::MultiArg< T >::_allowMore.

template<class T>
const_iterator TCLAP::MultiArg< T >::begin | ( |  | ) | const`[inline]`

| Returns an iterator over the values parsed from the command line. Definition at line 194 of file MultiArg.h.

template<class T>
const_iterator TCLAP::MultiArg< T >::end | ( |  | ) | const`[inline]`

| Returns the end of the values parsed from the command line. Definition at line 200 of file MultiArg.h.

template<class T>
const std::vector< T > & TCLAP::MultiArg< T >::getValue | ( |  | ) |

| Returns a vector of type T containing the values parsed from the command line. Definition at line 294 of file MultiArg.h.

template<class T>
bool TCLAP::MultiArg< T >::isRequired | ( |  | ) | const`[virtual]`

| Once we've matched the first value, then the arg is no longer required. Reimplemented from TCLAP::Arg. Definition at line 372 of file MultiArg.h. References TCLAP::MultiArg< T >::_values.

template<class T>
std::string TCLAP::MultiArg< T >::longID | ( | const std::string & | val = `"val"` | ) | const`[virtual]`

  | Used in the usage. Parameters:
  | val | - value to be used.
Reimplemented from TCLAP::Arg. Reimplemented in TCLAP::UnlabeledMultiArg< T >. Definition at line 361 of file MultiArg.h. References TCLAP::MultiArg< T >::_typeDesc.

template<class T>
bool TCLAP::MultiArg< T >::processArg | ( | int * | i,
|  | std::vector< std::string > & | args
| ) | `[virtual]`

  | Handles the processing of the argument. This re-implements the Arg version of this method to set the _value of the argument appropriately. It knows the difference between labeled and unlabeled. Parameters:
  | i | - Pointer the the current argument in the list.
  | args | - Mutable list of strings. Passed from main().
Implements TCLAP::Arg. Reimplemented in TCLAP::UnlabeledMultiArg< T >. Definition at line 297 of file MultiArg.h. References TCLAP::Arg::_checkWithVisitor(), TCLAP::MultiArg< T >::_extractValue(), TCLAP::Arg::_hasBlanks(), TCLAP::Arg::argMatches(), TCLAP::Arg::toString(), and TCLAP::Arg::trimFlag().

Here is the call graph for this function:

template<class T>
void TCLAP::MultiArg< T >::reset | ( |  | ) | `[virtual]`

| Clears the Arg object and allows it to be reused by new command lines. Reimplemented from TCLAP::Arg. Definition at line 414 of file MultiArg.h. References TCLAP::MultiArg< T >::_values.

template<class T>
std::string TCLAP::MultiArg< T >::shortID | ( | const std::string & | val = `"val"` | ) | const`[virtual]`

  | Used in the usage. Parameters:
  | val | - value to be used.
Reimplemented from TCLAP::Arg. Reimplemented in TCLAP::UnlabeledMultiArg< T >. Definition at line 351 of file MultiArg.h. References TCLAP::MultiArg< T >::_typeDesc.

## Member Data Documentation

template<class T>
bool TCLAP::MultiArg< T >::_allowMore`[protected]`

| Used by XorHandler to decide whether to keep parsing for this arg. Definition at line 74 of file MultiArg.h. Referenced by TCLAP::MultiArg< T >::allowMore().

template<class T>
Constraint<T>* TCLAP::MultiArg< T >::_constraint`[protected]`

| A list of constraint on this Arg. Definition at line 61 of file MultiArg.h. Referenced by TCLAP::MultiArg< T >::_extractValue().

template<class T>
std::string TCLAP::MultiArg< T >::_typeDesc`[protected]`

| The description of type T to be used in the usage. Definition at line 56 of file MultiArg.h. Referenced by TCLAP::MultiArg< T >::longID(), and TCLAP::MultiArg< T >::shortID().

template<class T>
std::vector<T> TCLAP::MultiArg< T >::_values`[protected]`

| The list of values parsed from the CmdLine. Definition at line 51 of file MultiArg.h. Referenced by TCLAP::MultiArg< T >::_extractValue(), TCLAP::MultiArg< T >::isRequired(), and TCLAP::MultiArg< T >::reset().

The documentation for this class was generated from the following file:

- MultiArg.h